import 'package:key_listener/src/key.dart';

abstract class KeySet {
  static const alphaNumeric = const <Key>[
    Key.one,
    Key.two,
    Key.three,
    Key.four,
    Key.five,
    Key.six,
    Key.seven,
    Key.eight,
    Key.nine,
    Key.zero,
    Key.A,
    Key.B,
    Key.C,
    Key.D,
    Key.E,
    Key.F,
    Key.G,
    Key.H,
    Key.I,
    Key.J,
    Key.K,
    Key.L,
    Key.M,
    Key.N,
    Key.O,
    Key.P,
    Key.Q,
    Key.R,
    Key.S,
    Key.T,
    Key.U,
    Key.V,
    Key.W,
    Key.X,
    Key.Y,
    Key.Z,
    Key.a,
    Key.b,
    Key.c,
    Key.d,
    Key.e,
    Key.f,
    Key.g,
    Key.h,
    Key.i,
    Key.j,
    Key.k,
    Key.l,
    Key.m,
    Key.n,
    Key.o,
    Key.p,
    Key.q,
    Key.r,
    Key.s,
    Key.t,
    Key.u,
    Key.v,
    Key.w,
    Key.x,
    Key.y,
    Key.z
  ];

  static const directional = const [Key.left, Key.right, Key.up, Key.down];

  static const punctuation = const <Key>[
    Key.bang,
    Key.at,
    Key.pound,
    Key.dollar,
    Key.percent,
    Key.caret,
    Key.ampersand,
    Key.star,
    Key.openParenthesis,
    Key.closeParenthesis,
    Key.underscore,
    Key.hyphen,
    Key.plus,
    Key.openBrace,
    Key.closeBrace,
    Key.colon,
    Key.semicolon,
    Key.doubleQuote,
    Key.singleQuote,
    Key.question,
    Key.pipe,
    Key.backSlash,
    Key.forwardSlash,
    Key.quote,
    Key.tilde
  ];

  static const comparison = const <Key>[
    Key.lessThan,
    Key.greaterThan,
    Key.equals
  ];

  static final visible = <Key>[]
    ..addAll(KeySet.alphaNumeric)
    ..addAll(KeySet.punctuation)
    ..addAll(KeySet.comparison);

  static const all = const <Key>[
    Key.del,
    Key.enter,
    Key.tab,
    Key.up,
    Key.down,
    Key.right,
    Key.left,
    Key.bang,
    Key.at,
    Key.pound,
    Key.dollar,
    Key.percent,
    Key.caret,
    Key.ampersand,
    Key.star,
    Key.openParenthesis,
    Key.closeParenthesis,
    Key.underscore,
    Key.hyphen,
    Key.plus,
    Key.openBrace,
    Key.closeBrace,
    Key.colon,
    Key.semicolon,
    Key.doubleQuote,
    Key.singleQuote,
    Key.lessThan,
    Key.greaterThan,
    Key.equals,
    Key.question,
    Key.pipe,
    Key.backSlash,
    Key.forwardSlash,
    Key.quote,
    Key.tilde,
    Key.space,
    Key.semicolon,
    Key.one,
    Key.two,
    Key.three,
    Key.four,
    Key.five,
    Key.six,
    Key.seven,
    Key.eight,
    Key.nine,
    Key.zero,
    Key.del,
    Key.enter,
    Key.tab,
    Key.up,
    Key.down,
    Key.right,
    Key.left,
    Key.A,
    Key.B,
    Key.C,
    Key.D,
    Key.E,
    Key.F,
    Key.G,
    Key.H,
    Key.I,
    Key.J,
    Key.K,
    Key.L,
    Key.M,
    Key.N,
    Key.O,
    Key.P,
    Key.Q,
    Key.R,
    Key.S,
    Key.T,
    Key.U,
    Key.V,
    Key.W,
    Key.X,
    Key.Y,
    Key.Z,
    Key.a,
    Key.b,
    Key.c,
    Key.d,
    Key.e,
    Key.f,
    Key.g,
    Key.h,
    Key.i,
    Key.j,
    Key.k,
    Key.l,
    Key.m,
    Key.n,
    Key.o,
    Key.p,
    Key.q,
    Key.r,
    Key.s,
    Key.t,
    Key.u,
    Key.v,
    Key.w,
    Key.x,
    Key.y,
    Key.z,
  ];
}
